package com.yihu.hos.broker.services;

import com.mongodb.BasicDBObject;
import com.mongodb.DBCollection;
import com.mongodb.Mongo;
import com.yihu.hos.core.log.Logger;
import com.yihu.hos.core.log.LoggerFactory;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component("centerMongoService")
public class CenterMongoService {
    private static final Logger logger = LoggerFactory.getLogger(CenterMongoService.class);
    @Autowired
    private Mongo centerMongo;

    public void log(String msg) {
        JSONArray jsonArray = new JSONArray(msg);
        JSONObject info = (JSONObject) jsonArray.get(0);
        String database = info.getString("database");
        String collection = info.getString("collection");
        DBCollection center = centerMongo.getDB(database).getCollection(collection);
        JSONObject record = (JSONObject) jsonArray.get(1);
        BasicDBObject dbObject = new BasicDBObject();
        for (Object key : record.keySet()) {
            dbObject.put((String) key, record.get((String) key).toString());
        }
        try {
            center.save(dbObject);
        } catch (Exception e) {
            e.printStackTrace();
        }

        System.out.println(info);
        System.out.println(record);
    }
}
