package com.yihu.hos;

import com.yihu.hos.interceptor.WebMvcInterceptor;
import com.yihu.hos.web.framework.constant.ServiceFlowConstant;
import com.yihu.hos.web.framework.util.GridFSUtil;
import org.apache.activemq.command.ActiveMQQueue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.data.mongodb.gridfs.GridFsOperations;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

import javax.jms.Queue;

@SpringBootApplication
public class ESBApplication extends WebMvcConfigurerAdapter {

    @Autowired
    private GridFsOperations operations;

    public static void main(String[] args) throws Exception {
        SpringApplication application = new SpringApplication(ESBApplication.class);
        application.run(args);
    }

    // 增加拦截器
    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        GridFSUtil.gridFsOperations = operations;
        registry.addInterceptor(new WebMvcInterceptor());
    }

    @Bean
    public Queue queue() {
        return new ActiveMQQueue(ServiceFlowConstant.FLOW_EVENT_QUEUE);
    }
}
